import { OnInit, OnChanges, SimpleChanges, DoCheck, EventEmitter } from "@angular/core";
import { ControlValueAccessor, FormControl } from "@angular/forms";
export declare const SELECTIZE_VALUE_ACCESSOR: any;
export declare class NgSelectizeComponent implements OnInit, OnChanges, DoCheck, ControlValueAccessor {
    config: any;
    options: any[];
    optionGroups: any[];
    placeholder: string;
    hasOptionsPlaceholder: string;
    noOptionsPlaceholder: string;
    enabled: boolean;
    _value: string[];
    formControl: FormControl;
    errorClass: string;
    onBlur: EventEmitter<void>;
    selectizeInput: any;
    private selectize;
    private _oldOptions;
    private _oldOptionGroups;
    private onTouchedCallback;
    private onChangeCallback;
    constructor();
    ngOnInit(): void;
    reset(): void;
    /**
     * Change detection for primitive types.
     */
    ngOnChanges(changes: SimpleChanges): void;
    /**
     * Implementing deep check for option comparison
     *
     * FIXME -> Implement deep check to only compare against label and value fields.
     */
    ngDoCheck(): void;
    onBlurEvent(): void;
    /**
     * Refresh selected values when options change.
     */
    onSelectizeOptionAdd(optionValue: string): void;
    evalHasError(): void;
    /**
     * Update the current placeholder based on the given input parameter.
     */
    updatePlaceholder(): void;
    /**
     * Called when a change is detected in the 'enabled' input field.
     * Sets the selectize state based on the new value.
     */
    onEnabledStatusChange(): void;
    /**
     * Triggered when a change is detected with the given set of options.
     */
    onSelectizeOptionsChange(): void;
    /**
     * Triggered when a change is detected with the given set of option groups.
     */
    onSelectizeOptionGroupChange(): void;
    /**
     * Dispatches change event when a value change is detected.
     * @param $event
     */
    onSelectizeValueChange($event: any): void;
    /**
     * Returns the applicable placeholder.
     */
    getPlaceholder(): string;
    /**
     * Implementation from ControlValueAccessor
     *
     * Empty check on 'obj' removed due to restriction on resetting the field.
     * From testing, async should still function appropriately.
     *
     * FIXME This might not be necessary anymore..
     *
     * @param obj
     */
    writeValue(obj: any): void;
    /**
     * Implementation from ControlValueAccessor, callback for (ngModelChange)
     * @param fn
     */
    registerOnChange(fn: any): void;
    /**
     * Implementation from ControlValueAccessor
     * @param fn
     */
    registerOnTouched(fn: any): void;
    value: string[];
}
